#!/usr/bin/env python
# coding: utf-8

from __future__ import unicode_literals

import os
import argparse
import poste
import sys

import test_conf as conf
#os.environ['SSL_CERT_FILE'] = '/etc/ssl/certs/ca-certificates.crt' 
os.environ['SSL_CERT_FILE'] = '/code/tests/certs.pem' 

def main():
    parser = argparse.ArgumentParser(description="Test posteonline credentials")
    parser.add_argument('-r', '--rol', action='store_true', help='test rol')
    parser.add_argument('-l', '--lol', action='store_true', help='test lol')
    parser.add_argument('-t', '--tol', action='store_true', help='test tol')
    parser.add_argument('-w', '--wsdl', help='use wsdl provided as file')
    parser.add_argument('-T', '--test', action='store_true', default=False, help='TEST')
    parser.add_argument('-P', '--prod', action='store_true', default=False, help='PROD')
    parser.add_argument('-v', '--verbosity', type=int, choices=[0, 1, 2], default=1, help='verbosity level')
    args = parser.parse_args()

    # Queste credenziali dovrebbero essere gestite in modo sicuro, ad esempio usando variabili d'ambiente
    if args.prod:
        username = conf.PROD_USERNAME
        password = conf.PROD_PASSWORD
        service_level = 'PROD'
    else:
        username = conf.TEST_USERNAME
        password = conf.TEST_PASSWORD
        service_level = 'TEST'

    if args.tol:
        print("Testing Tol (%s)... " % service_level, end="")
        xol_client = poste.TOLClient
    elif args.lol:
        xol_client = poste.LOLClient
        print("Testing Lol (%s)... " % service_level, end="")
    else:
        xol_client = poste.ROLClient
        print("Testing Rol (%s)... " % service_level, end="")

    if args.verbosity in (1, 2):
        print("Credentials", username, password, service_level)

    try:
        xol = xol_client(username=username, password=password, service_level=service_level, url=args.wsdl)
        print(xol)
        print("OK!")
    except Exception as e:
        print(e)
        sys.exit(1)

if __name__ == "__main__":
    main()
