# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import sys

from copy import copy
from unittest import TestCase

import poste

sys.path.append(".")

from test_conf import TEST_USERNAME, TEST_PASSWORD


THUNDER_ADDR = {
    'nome': 'Vittorino',
    'cognome': 'Parenti',
    'ragione_sociale': 'Thunder Systems',
    'citta': 'Pioltello',
    'indirizzo': 'Via Dante Alighieri 99',
    'cap': '20096',
}


# def setUp():

#     global tol

#     poste.debug(False)
#     tol = poste.TOLClient(username=TEST_USERNAME, password=TEST_PASSWORD, service_level='TEST')


class TOLTestClient(TestCase):

    @classmethod
    def setUpClass(cls):
        poste.debug(False)
        cls.tol = poste.TOLClient(username=TEST_USERNAME, password=TEST_PASSWORD, service_level='TEST')

    def setUp(self):
        self.addr = copy(THUNDER_ADDR)

    def test_01(self):
        "Verifica destinatario - THUNDER"

        thunder = poste.RecipientTOL(**self.addr)
        result = self.tol.valida_destinatario(thunder)
        assert result

    def test_02(self):
        "Verifica destinatario errato - Thunder a Limito di Pioltello"

        self.addr['citta'] = 'Limito di Pioltello'
        thunder = poste.RecipientTOL(**self.addr)
        self.assertRaises(poste.RemoteRecipientValidationError, self.tol.valida_destinatario, thunder)

    def test_03(self):
        "Verifica destinatario errato - senza cap"

        self.addr['cap'] = ''
        self.assertRaises(poste.RecipientValidationError, poste.RecipientTOL, **self.addr)
